Index: doc/theses/andrew_beach_MMath/features.tex
===================================================================
--- doc/theses/andrew_beach_MMath/features.tex	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ doc/theses/andrew_beach_MMath/features.tex	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -124,5 +124,4 @@
 
 \section{Virtuals}
-\label{s:virtuals}
 Virtual types and casts are not part of \CFA's EHM nor are they required for
 any EHM.
Index: doc/theses/andrew_beach_MMath/performance.tex
===================================================================
--- doc/theses/andrew_beach_MMath/performance.tex	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ doc/theses/andrew_beach_MMath/performance.tex	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -2,20 +2,20 @@
 \label{c:performance}
 
-Performance is of secondary importance for most of this project.
-Instead, the focus is to get the features working. The only performance
-requirement is to ensure the tests for correctness run in a reasonable
+Performance has been of secondary importance for most of this project.
+Instead, the focus has been to get the features working. The only performance
+requirements is to ensure the tests for correctness run in a reasonable
 amount of time.
 
 \section{Test Set-Up}
-Tests were run in \CFA, C++, Java and Python.
+Tests will be run in \CFA, C++, Java and Python.
 In addition there are two sets of tests for \CFA,
-one for termination and one for resumption exceptions.
+one for termination exceptions and once with resumption exceptions.
 
 C++ is the most comparable language because both it and \CFA use the same
 framework, libunwind.
 In fact, the comparison is almost entirely a quality of implementation
-comparison: \CFA's EHM has had significantly less time to be optimized and
+comparison. \CFA's EHM has had significantly less time to be optimized and
 does not generate its own assembly. It does have a slight advantage in that
-there are some features it handles directly instead of through utility functions,
+there are some features it does not handle, through utility functions,
 but otherwise \Cpp has a significant advantage.
 
@@ -23,29 +23,30 @@
 It is implemented in a very different environment, a virtual machine with
 garbage collection.
-It also implements the @finally@ clause on @try@ blocks allowing for a direct
+It also implements the finally clause on try blocks allowing for a direct
 feature-to-feature comparison.
-As with \Cpp, Java's implementation is mature, optimizations
-and has extra features.
-
-Python is used as an alternative point of comparison because of the \CFA EHM's
-current performance goals, which is not to be prohibitively slow while the
+As with \Cpp, Java's implementation is more mature, has more optimizations
+and more extra features.
+
+Python was used as a point of comparison because of the \CFA EHM's
+current performance goals, which is not be prohibitively slow while the
 features are designed and examined. Python has similar performance goals for
 creating quick scripts and its wide use suggests it has achieved those goals.
 
-Unfortunately, there are no notable modern programming languages with
-resumption exceptions. Even the older programming languages with resumption
-seem to be notable only for having resumption.
-So instead, resumption is compared to a less similar but much more familiar
+Unfortunately there are no notable modern programming languages with
+resumption exceptions. Even the older programming languages with resumptions
+seem to be notable only for having resumptions.
+So instead resumptions are compared to a less similar but much more familiar
 feature, termination exceptions.
 
-All tests are run inside a main loop that repeatedly performs a test.
-This approach avoids start-up or tear-down time from
+All tests are run inside a main loop which will perform the test
+repeatedly. This is to avoids start-up or tear-down time from
 affecting the timing results.
-Each test is run a million times.
-The Java versions of the test run this loop an extra 1000 times before
-beginning to actual test to ``warm-up" the JVM.
+Tests ran their main loop a million times.
+The Java versions of the test also run this loop an extra 1000 times before
+beginning to time the results to ``warm-up" the JVM.
 
 Timing is done internally, with time measured immediately before and
-after the test loop. The difference is calculated and printed.
+immediately after the test loop. The difference is calculated and printed.
+
 The loop structure and internal timing means it is impossible to test
 unhandled exceptions in \Cpp and Java as that would cause the process to
@@ -54,23 +55,12 @@
 critical.
 
-The exceptions used in these tests are always based off of
-a base exception. This requirement minimizes performance differences based
-on the object model used to represent the exception.
-
-All tests are designed to be as minimal as possible, while still preventing
-excessive optimizations.
+The exceptions used in these tests will always be a exception based off of
+the base exception. This requirement minimizes performance differences based
+on the object model used to repersent the exception.
+
+All tests were designed to be as minimal as possible while still preventing
+exessive optimizations.
 For example, empty inline assembly blocks are used in \CFA and \Cpp to
 prevent excessive optimizations while adding no actual work.
-Each test was run eleven times. The top three and bottom three results were
-discarded and the remaining five values are averaged.
-
-The tests are compiled with gcc-10 for \CFA and g++-10 for \Cpp. Java is
-compiled with 11.0.11. Python with 3.8. The tests were run on:
-\begin{itemize}[nosep]
-\item
-ARM 2280 Kunpeng 920 48-core 2$\times$socket \lstinline{@} 2.6 GHz running Linux v5.11.0-25
-\item
-AMD 6380 Abu Dhabi 16-core 4$\times$socket \lstinline{@} 2.5 GHz running Linux v5.11.0-25
-\end{itemize}
 
 % We don't use catch-alls but if we did:
@@ -81,97 +71,45 @@
 The following tests were selected to test the performance of different
 components of the exception system.
-They should provide a guide as to where the EHM's costs are found.
+The should provide a guide as to where the EHM's costs can be found.
 
 \paragraph{Raise and Handle}
-The first group measures the cost of a try statement when exceptions are raised
-and \emph{the stack is unwound}.  Each test has has a repeating function like
-the following
-\begin{cfa}
-void unwind_empty(unsigned int frames) {
-	if (frames) {
-		unwind_empty(frames - 1);
-	} else throw (empty_exception){&empty_vt};
-}
-\end{cfa}
-which is called M times, where each call recurses to a depth of N, an
-exception is raised, the stack is a unwound, and the exception caught.
+The first group of tests involve setting up
+So there is three layers to the test. The first is set up and a loop, which
+configures the test and then runs it repeatedly to reduce the impact of
+start-up and shutdown on the results.
+Each iteration of the main loop
 \begin{itemize}[nosep]
-\item Empty:
-This test measures the cost of raising (stack walking) an exception through empty
-empty stack frames to an empty handler. (see above)
+\item Empty Function:
+The repeating function is empty except for the necessary control code.
 \item Destructor:
-
-This test measures the cost of raising an exception through non-empty frames
-where each frame has an object requiring destruction, to an empty
-handler. Hence, there are N destructor calls during unwinding.
-\begin{cfa}
-if (frames) {
-	WithDestructor object;
-	unwind_empty(frames - 1);
-\end{cfa}
+The repeating function creates an object with a destructor before calling
+itself.
 \item Finally:
-This test measures the cost of establishing a try block with an empty finally
-clause on the front side of the recursion and running the empty finally clause
-on the back side of the recursion during stack unwinding.
-\begin{cfa}
-if (frames) {
-	try {
-		unwind_finally(frames - 1);
-	} finally {}
-\end{cfa}
+The repeating function calls itself inside a try block with a finally clause
+attached.
 \item Other Handler:
-This test is like the finally test but the try block has a catch clause for an
-exception that is not raised, so catch matching is executed during stack
-unwinding but the match never successes until the catch at the bottom of the
-stack.
-\begin{cfa}
-if (frames) {
-	try {
-		unwind_other(frames - 1);
-	} catch (not_raised_exception *) {}
-\end{cfa}
+The repeating function calls itself inside a try block with a handler that
+will not match the raised exception. (But is of the same kind of handler.)
 \end{itemize}
 
 \paragraph{Cross Try Statement}
-The next group measures just the cost of executing a try statement so
-\emph{there is no stack unwinding}.  Hence, the program main loops N times
-around:
-\begin{cfa}
-try {
-} catch (not_raised_exception *) {}
-\end{cfa}
+The next group measures the cost of a try statement when no exceptions are
+raised. The test is set-up, then there is a loop to reduce the impact of
+start-up and shutdown on the results.
+In each iteration, a try statement is executed. Entering and leaving a loop
+is all the test wants to do.
 \begin{itemize}[nosep]
 \item Handler:
-The try statement has a handler.
+The try statement has a handler (of the matching kind).
 \item Finally:
-The try statement replaces the handler with a finally clause.
+The try statement has a finally clause.
 \end{itemize}
 
 \paragraph{Conditional Matching}
-This final group measures the cost of conditional matching.
+This group of tests checks the cost of conditional matching.
 Only \CFA implements the language level conditional match,
 the other languages must mimic with an ``unconditional" match (it still
 checks the exception's type) and conditional re-raise if it was not supposed
 to handle that exception.
-\begin{center}
-\begin{tabular}{ll}
-\multicolumn{1}{c}{\CFA} & \multicolumn{1}{c}{\Cpp, Java, Python} \\
-\begin{cfa}
-try {
-	throw_exception();
-} catch (empty_exception * exc;
-		 should_catch) {
-}
-\end{cfa}
-&
-\begin{cfa}
-try {
-	throw_exception();
-} catch (EmptyException & exc) {
-	if (!should_catch) throw;
-}
-\end{cfa}
-\end{tabular}
-\end{center}
 \begin{itemize}[nosep]
 \item Match All:
@@ -192,12 +130,11 @@
 
 \section{Results}
+Each test was run eleven times. The top three and bottom three results were
+discarded and the remaining five values are averaged.
+
 In cases where a feature is not supported by a language the test is skipped
-for that language.
-\PAB{Report all values.
-
-Similarly, if a test does not change between resumption
+for that language. Similarly, if a test is does not change between resumption
 and termination in \CFA, then only one test is written and the result
 was put into the termination column.
-}
 
 % Raw Data:
@@ -300,23 +237,24 @@
 \end{tabular}
 
-One result not directly related to \CFA but important to keep in
-mind is that, for exceptions, the standard intuition about which languages
-should go faster often does not hold. For example, there are cases where Python out-performs
-\Cpp and Java. The most likely explanation is that, since exceptions are
-rarely considered to be the common case, the more optimized languages
-make that case expense. In addition, languages with high-level
-representations have a much easier time scanning the stack as there is less
+One result that is not directly related to \CFA but is important to keep in
+mind is that in exceptions the standard intuitions about which languages
+should go faster often do not hold. There are cases where Python out-preforms
+\Cpp and Java. The most likely explination is that, since exceptions are
+rarely considered to be the common case, the more optimized langages have 
+optimized at their expence. In addition languages with high level            
+repersentations have a much easier time scanning the stack as there is less
 to decode.
 
-This observation means that while \CFA does not actually keep up with Python in every
-case, it is usually no worse than roughly half the speed of \Cpp. This performance is good
+This means that while \CFA does not actually keep up with Python in every
+case it is usually no worse than roughly half the speed of \Cpp. This is good
 enough for the prototyping purposes of the project.
 
 The test case where \CFA falls short is Raise Other, the case where the
 stack is unwound including a bunch of non-matching handlers.
-This slowdown seems to come from missing optimizations.
-
+This slowdown seems to come from missing optimizations,
+the results above came from gcc/g++ 10 (gcc as \CFA backend or g++ for \Cpp)
+but the results change if they are run in gcc/g++ 9 instead.
 Importantly, there is a huge slowdown in \Cpp's results bringing that brings
-\CFA's performance back in that roughly half speed area. However many other
+\CFA's performace back in that roughly half speed area. However many other
 \CFA benchmarks increase their run-time by a similar amount falling far
 behind their \Cpp counter-parts.
@@ -331,8 +269,8 @@
 Resumption exception handling is also incredibly fast. Often an order of
 magnitude or two better than the best termination speed.
-There is a simple explanation for this; traversing a linked list is much   
+There is a simple explination for this; traversing a linked list is much   
 faster than examining and unwinding the stack. When resumption does not do as
-well its when more try statements are used per raise. Updating the internal
-linked list is not very expensive but it does add up.
+well its when more try statements are used per raise. Updating the interal
+linked list is not very expencive but it does add up.
 
 The relative speed of the Match All and Match None tests (within each
@@ -342,10 +280,10 @@
 \item
 Java and Python get similar values in both tests.
-Between the interpreted code, a higher level representation of the call
+Between the interperated code, a higher level repersentation of the call
 stack and exception reuse it it is possible the cost for a second
 throw can be folded into the first.
 % Is this due to optimization?
 \item
-Both types of \CFA are slightly slower if there is not a match.
+Both types of \CFA are slighly slower if there is not a match.
 For termination this likely comes from unwinding a bit more stack through
 libunwind instead of executing the code normally.
Index: c/theses/andrew_beach_MMath/vtable.fig
===================================================================
--- doc/theses/andrew_beach_MMath/vtable.fig	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ 	(revision )
@@ -1,42 +1,0 @@
-#FIG 3.2  Produced by xfig version 3.2.7b
-Landscape
-Center
-Metric
-A4
-100.00
-Single
--2
-1200 2
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 1260 1350 1485 1665
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 1260 1350 1035 1665
-2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 1263 1346 1578 1571
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 2520 1350 2520 1665
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 2520 1800 2520 2115
-2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 2520 1350 2835 1575
-2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 2517 1804 2832 2029
-4 1 0 50 -1 5 12 0.0000 2 120 240 1035 1800 V1\001
-4 1 0 50 -1 5 12 0.0000 2 120 240 1485 1800 V2\001
-4 1 0 50 -1 5 12 0.0000 2 120 240 1260 1350 V0\001
-4 0 0 50 -1 0 11 0.0000 2 135 420 1620 1665 vtable\001
-4 1 0 50 -1 5 12 0.0000 2 120 240 2520 1350 W0\001
-4 1 0 50 -1 5 12 0.0000 2 120 240 2520 2250 W2\001
-4 1 0 50 -1 5 12 0.0000 2 120 240 2520 1800 W1\001
-4 0 0 50 -1 0 11 0.0000 2 135 420 2880 1620 vtable\001
-4 0 0 50 -1 0 11 0.0000 2 135 420 2880 2070 vtable\001
-4 1 0 50 -1 0 12 0.0000 2 180 1365 1935 1080 virtual type trees\001
-4 0 0 50 -1 5 11 0.0000 2 150 735 3060 1755 Id; <,+\001
-4 0 0 50 -1 5 11 0.0000 2 150 1155 3060 2250 Id; <,+,w,-\001
Index: libcfa/src/concurrency/kernel/startup.cfa
===================================================================
--- libcfa/src/concurrency/kernel/startup.cfa	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ libcfa/src/concurrency/kernel/startup.cfa	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -235,5 +235,4 @@
 
 	register_tls( mainProcessor );
-	mainThread->last_cpu = __kernel_getcpu();
 
 	//initialize the global state variables
@@ -479,4 +478,5 @@
 	state = Start;
 	self_cor{ info };
+	last_cpu = __kernel_getcpu();
 	curr_cor = &self_cor;
 	curr_cluster = mainCluster;
Index: libcfa/src/concurrency/thread.cfa
===================================================================
--- libcfa/src/concurrency/thread.cfa	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ libcfa/src/concurrency/thread.cfa	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -34,7 +34,5 @@
 	preempted = __NO_PREEMPTION;
 	corctx_flag = false;
-	disable_interrupts();
 	last_cpu = __kernel_getcpu();
-	enable_interrupts();
 	curr_cor = &self_cor;
 	self_mon.owner = &this;
Index: libcfa/src/heap.cfa
===================================================================
--- libcfa/src/heap.cfa	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ libcfa/src/heap.cfa	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -10,6 +10,6 @@
 // Created On       : Tue Dec 19 21:58:35 2017
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Aug  9 19:03:02 2021
-// Update Count     : 1040
+// Last Modified On : Sat May 22 08:46:39 2021
+// Update Count     : 1036
 //
 
@@ -102,5 +102,4 @@
 } // prtUnfreed
 
-extern int cfa_main_returned;							// from bootloader.cf
 extern "C" {
 	void heapAppStart() {								// called by __cfaabi_appready_startup
@@ -110,5 +109,5 @@
 	void heapAppStop() {								// called by __cfaabi_appready_startdown
 		fclose( stdin ); fclose( stdout );
-		if ( cfa_main_returned ) prtUnfreed();			// do not check unfreed storage if exit called
+		prtUnfreed();
 	} // heapAppStop
 } // extern "C"
Index: src/Parser/ExpressionNode.cc
===================================================================
--- src/Parser/ExpressionNode.cc	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ src/Parser/ExpressionNode.cc	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -10,6 +10,6 @@
 // Created On       : Sat May 16 13:17:07 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Aug  7 09:18:56 2021
-// Update Count     : 1077
+// Last Modified On : Thu Aug 20 14:01:46 2020
+// Update Count     : 1076
 //
 
@@ -514,5 +514,4 @@
 	return expr;
 } // build_varref
-
 // TODO: get rid of this and OperKinds and reuse code from OperatorTable
 static const char * OperName[] = {						// must harmonize with OperKinds
Index: tests/.expect/declarationSpecifier.arm64.txt
===================================================================
--- tests/.expect/declarationSpecifier.arm64.txt	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/.expect/declarationSpecifier.arm64.txt	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -1132,5 +1132,4 @@
 char **_X13cfa_args_argvPPc_1;
 char **_X13cfa_args_envpPPc_1;
-signed int _X17cfa_main_returnedi_1 = ((signed int )0);
 signed int main(signed int _X4argci_1, char **_X4argvPPc_1, char **_X4envpPPc_1){
     __attribute__ ((unused)) signed int _X12_retval_maini_1;
@@ -1147,12 +1146,7 @@
     }
 
-    signed int _tmp_cp_ret6;
-    signed int _X3reti_2 = (((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6);
-    {
-        ((void)(_X17cfa_main_returnedi_1=((signed int )1)));
-    }
-
-    {
-        ((void)(_X12_retval_maini_1=_X3reti_2) /* ?{} */);
+    {
+        signed int _tmp_cp_ret6;
+        ((void)(_X12_retval_maini_1=(((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6)) /* ?{} */);
     }
 
Index: tests/.expect/declarationSpecifier.x64.txt
===================================================================
--- tests/.expect/declarationSpecifier.x64.txt	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/.expect/declarationSpecifier.x64.txt	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -1132,5 +1132,4 @@
 char **_X13cfa_args_argvPPc_1;
 char **_X13cfa_args_envpPPc_1;
-signed int _X17cfa_main_returnedi_1 = ((signed int )0);
 signed int main(signed int _X4argci_1, char **_X4argvPPc_1, char **_X4envpPPc_1){
     __attribute__ ((unused)) signed int _X12_retval_maini_1;
@@ -1147,12 +1146,7 @@
     }
 
-    signed int _tmp_cp_ret6;
-    signed int _X3reti_2 = (((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6);
-    {
-        ((void)(_X17cfa_main_returnedi_1=((signed int )1)));
-    }
-
-    {
-        ((void)(_X12_retval_maini_1=_X3reti_2) /* ?{} */);
+    {
+        signed int _tmp_cp_ret6;
+        ((void)(_X12_retval_maini_1=(((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6)) /* ?{} */);
     }
 
Index: tests/.expect/declarationSpecifier.x86.txt
===================================================================
--- tests/.expect/declarationSpecifier.x86.txt	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/.expect/declarationSpecifier.x86.txt	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -1132,5 +1132,4 @@
 char **_X13cfa_args_argvPPc_1;
 char **_X13cfa_args_envpPPc_1;
-signed int _X17cfa_main_returnedi_1 = ((signed int )0);
 signed int main(signed int _X4argci_1, char **_X4argvPPc_1, char **_X4envpPPc_1){
     __attribute__ ((unused)) signed int _X12_retval_maini_1;
@@ -1147,12 +1146,7 @@
     }
 
-    signed int _tmp_cp_ret6;
-    signed int _X3reti_2 = (((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6);
-    {
-        ((void)(_X17cfa_main_returnedi_1=((signed int )1)));
-    }
-
-    {
-        ((void)(_X12_retval_maini_1=_X3reti_2) /* ?{} */);
+    {
+        signed int _tmp_cp_ret6;
+        ((void)(_X12_retval_maini_1=(((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6)) /* ?{} */);
     }
 
Index: tests/.expect/gccExtensions.arm64.txt
===================================================================
--- tests/.expect/gccExtensions.arm64.txt	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/.expect/gccExtensions.arm64.txt	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -324,5 +324,4 @@
 char **_X13cfa_args_argvPPc_1;
 char **_X13cfa_args_envpPPc_1;
-signed int _X17cfa_main_returnedi_1 = ((signed int )0);
 signed int main(signed int _X4argci_1, char **_X4argvPPc_1, char **_X4envpPPc_1){
     __attribute__ ((unused)) signed int _X12_retval_maini_1;
@@ -339,12 +338,7 @@
     }
 
-    signed int _tmp_cp_ret6;
-    signed int _X3reti_2 = (((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6);
-    {
-        ((void)(_X17cfa_main_returnedi_1=((signed int )1)));
-    }
-
-    {
-        ((void)(_X12_retval_maini_1=_X3reti_2) /* ?{} */);
+    {
+        signed int _tmp_cp_ret6;
+        ((void)(_X12_retval_maini_1=(((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6)) /* ?{} */);
     }
 
Index: tests/.expect/gccExtensions.x64.txt
===================================================================
--- tests/.expect/gccExtensions.x64.txt	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/.expect/gccExtensions.x64.txt	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -324,5 +324,4 @@
 char **_X13cfa_args_argvPPc_1;
 char **_X13cfa_args_envpPPc_1;
-signed int _X17cfa_main_returnedi_1 = ((signed int )0);
 signed int main(signed int _X4argci_1, char **_X4argvPPc_1, char **_X4envpPPc_1){
     __attribute__ ((unused)) signed int _X12_retval_maini_1;
@@ -339,12 +338,7 @@
     }
 
-    signed int _tmp_cp_ret6;
-    signed int _X3reti_2 = (((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6);
-    {
-        ((void)(_X17cfa_main_returnedi_1=((signed int )1)));
-    }
-
-    {
-        ((void)(_X12_retval_maini_1=_X3reti_2) /* ?{} */);
+    {
+        signed int _tmp_cp_ret6;
+        ((void)(_X12_retval_maini_1=(((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6)) /* ?{} */);
     }
 
Index: tests/.expect/gccExtensions.x86.txt
===================================================================
--- tests/.expect/gccExtensions.x86.txt	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/.expect/gccExtensions.x86.txt	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -302,5 +302,4 @@
 char **_X13cfa_args_argvPPc_1;
 char **_X13cfa_args_envpPPc_1;
-signed int _X17cfa_main_returnedi_1 = ((signed int )0);
 signed int main(signed int _X4argci_1, char **_X4argvPPc_1, char **_X4envpPPc_1){
     __attribute__ ((unused)) signed int _X12_retval_maini_1;
@@ -317,12 +316,7 @@
     }
 
-    signed int _tmp_cp_ret6;
-    signed int _X3reti_2 = (((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6);
-    {
-        ((void)(_X17cfa_main_returnedi_1=((signed int )1)));
-    }
-
-    {
-        ((void)(_X12_retval_maini_1=_X3reti_2) /* ?{} */);
+    {
+        signed int _tmp_cp_ret6;
+        ((void)(_X12_retval_maini_1=(((void)(_tmp_cp_ret6=invoke_main(_X4argci_1, _X4argvPPc_1, _X4envpPPc_1))) , _tmp_cp_ret6)) /* ?{} */);
     }
 
Index: tests/bitmanip3.cfa
===================================================================
--- tests/bitmanip3.cfa	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/bitmanip3.cfa	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -10,6 +10,6 @@
 // Created On       : Tue Apr  7 21:22:59 2020
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sun Aug  8 23:12:19 2021
-// Update Count     : 76
+// Last Modified On : Mon Aug 24 09:53:26 2020
+// Update Count     : 66
 // 
 
@@ -133,83 +133,73 @@
 	sout | nl | "floor2" | nl | nl;
 
-	sout | "signed char";
+	printf( "signed char\n" );
 	for ( sc = 1; sc != 0; sc <<= 1 ) {
 		scr1 = floor2( sc, sc ); scr2 = floor2( sc + 2hh, sc ); scr3 = floor2( -sc - 2hh, sc );
-//		printf( "floor2(%hhd, %hhd) = %hhd, floor2(%hhd, %hhd) = %hhd, floor2(%hhd, %hhd) = %hhd\n", sc, sc, scr1, sc + 2hh, sc, scr2, -sc - 2hh, sc, scr3 );
-		sout | "floor2(" | sc | "," | sc | ") = " | scr1 | ", floor2(" | sc + 2hh | "," | sc | ") = " | scr2 | ", floor2(" | -sc - 2hh | "," | sc | ") = " | scr3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned char";
+		printf( "floor2(%hhd, %hhd) = %hhd, floor2(%hhd, %hhd) = %hhd, floor2(%hhd, %hhd) = %hhd\n", sc, sc, scr1, sc + 2hh, sc, scr2, -sc - 2hh, sc, scr3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned char\n" );
 	for ( uc = 1; uc != 0; uc <<= 1 ) {
 		ucr1 = floor2( uc, uc ); ucr2 = floor2( uc + 2hh, uc ); ucr3 = floor2( -uc - 2hh, uc );
-//		printf( "floor2(%hhu, %hhu) = %hhu, floor2(%hhu, %hhu) = %hhu, floor2(%hhu, %hhu) = %hhu\n", uc, uc, ucr1, uc + 2uhh, uc, ucr2, -uc - 2uhh, uc, ucr3 );
-		sout | "floor2(" | uc | "," | uc | ") = " | ucr1 | ", floor2(" | uc + 2uhh | "," | uc | ") = " | ucr2 | ", floor2(" | -uc - 2uhh | "," | uc | ") = " | ucr3;
-	} // for
-	sout | nl;
-
-	sout | "short int";
+		printf( "floor2(%hhu, %hhu) = %hhu, floor2(%hhu, %hhu) = %hhu, floor2(%hhu, %hhu) = %hhu\n", uc, uc, ucr1, uc + 2uhh, uc, ucr2, -uc - 2uhh, uc, ucr3 );
+	} // for
+	printf( "\n" );
+
+	printf( "short int\n" );
 	for ( si = 1; si != 0; si <<= 1 ) {
 		sir1 = floor2( si, si ); sir2 = floor2( si + 2hh, si ); sir3 = floor2( -si - 2hh, si );
-//		printf( "floor2(%hd, %hd) = %hd, floor2(%hd, %hd) = %hd, floor2(%hd, %hd) = %hd\n", si, si, sir1, si + 2h, si, sir2, -si - 2h, si, sir3 );
-		sout | "floor2(" | si | "," | si | ") = " | sir1 | ", floor2(" | si + 2h | "," | si | ") = " | sir2 | ", floor2(" | -si - 2h | "," | si | ") = " | sir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned short int";
+		printf( "floor2(%hd, %hd) = %hd, floor2(%hd, %hd) = %hd, floor2(%hd, %hd) = %hd\n", si, si, sir1, si + 2h, si, sir2, -si - 2h, si, sir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned short int\n" );
 	for ( usi = 1; usi != 0; usi <<= 1 ) {
 		usir1 = floor2( usi, usi ); usir2 = floor2( usi + 2hh, usi ); usir3 = floor2( -usi - 2hh, usi );
-//		printf( "floor2(%hu, %hu) = %hu, floor2(%hu, %hu) = %hu, floor2(%hu, %hu) = %hu\n", usi, usi, usir1, usi + 2uh, usi, usir2, -usi - 2uh, usi, usir3 );
-		sout | "floor2(" | usi | "," | usi | ") = " | usir1 | ", floor2(" | usi + 2uh | "," | usi | ") = " | usir2 | ", floor2(" | -usi - 2uh | "," | usi | ") = " | usir3;
-	} // for
-	sout | nl;
-
-	sout | "int";
+		printf( "floor2(%hu, %hu) = %hu, floor2(%hu, %hu) = %hu, floor2(%hu, %hu) = %hu\n", usi, usi, usir1, usi + 2uh, usi, usir2, -usi - 2uh, usi, usir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "int\n" );
 	for ( i = 1; i != 0; i <<= 1 ) {
 		ir1 = floor2( i, i ); ir2 = floor2( i + 2hh, i ); ir3 = floor2( -i - 2hh, i );
-//		printf( "floor2(%d, %d) = %d, floor2(%d, %d) = %d, floor2(%d, %d) = %d\n", i, i, ir1, i + 2, i, ir2, -i - 2, i, ir3 );
-		sout | "floor2(" | i | "," | i | ") = " | ir1 | ", floor2(" | i + 2 | "," | i | ") = " | ir2 | ", floor2(" | -i - 2 | "," | i | ") = " | ir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned int";
+		printf( "floor2(%d, %d) = %d, floor2(%d, %d) = %d, floor2(%d, %d) = %d\n", i, i, ir1, i + 2h, i, ir2, -i - 2h, i, ir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned int\n" );
 	for ( ui = 1; ui != 0; ui <<= 1 ) {
 		uir1 = floor2( ui, ui ); uir2 = floor2( ui + 2hh, ui ); uir3 = floor2( -ui - 2hh, ui );
-//		printf( "floor2(%u, %u) = %u, floor2(%u, %u) = %u, floor2(%u, %u) = %u\n", ui, ui, uir1, ui + 2, ui, uir2, -ui - 2, ui, uir3 );
-		sout | "floor2(" | ui | "," | ui | ") = " | uir1 | ", floor2(" | ui + 2 | "," | ui | ") = " | uir2 | ", floor2(" | -ui - 2 | "," | ui | ") = " | uir3;
-	} // for
-	sout | nl;
-
-	sout | "long int";
+		printf( "floor2(%u, %u) = %u, floor2(%u, %u) = %u, floor2(%u, %u) = %u\n", ui, ui, uir1, ui + 2h, ui, uir2, -ui - 2h, ui, uir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "long int\n" );
 	for ( li = 1; li != 0; li <<= 1 ) {
 		lir1 = floor2( li, li ); lir2 = floor2( li + 2hh, li ); lir3 = floor2( -li - 2hh, li );
-//		printf( "floor2(%ld, %ld) = %ld, floor2(%ld, %ld) = %ld, floor2(%ld, %ld) = %ld\n", li, li, lir1, li + 2l, li, lir2, -li - 2l, li, lir3 );
-		sout | "floor2(" | li | "," | li | ") = " | lir1 | ", floor2(" | li + 2l | "," | li | ") = " | lir2 | ", floor2(" | -li - 2l | "," | li | ") = " | lir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned long int";
+		printf( "floor2(%ld, %ld) = %ld, floor2(%ld, %ld) = %ld, floor2(%ld, %ld) = %ld\n", li, li, lir1, li + 2h, li, lir2, -li - 2h, li, lir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned long int\n" );
 	for ( uli = 1; uli != 0; uli <<= 1 ) {
 		ulir1 = floor2( uli, uli ); ulir2 = floor2( uli + 2hh, uli ); ulir3 = floor2( -uli - 2hh, uli );
-//		printf( "floor2(%lu, %lu) = %lu, floor2(%lu, %lu) = %lu, floor2(%lu, %lu) = %lu\n", uli, uli, ulir1, uli + 2l, uli, ulir2, -uli - 2l, uli, ulir3 );
-		sout | "floor2(" | uli | "," | uli | ") = " | ulir1 | ", floor2(" | uli + 2l | "," | uli | ") = " | ulir2 | ", floor2(" | -uli - 2l | "," | uli | ") = " | ulir3;
-	} // for
-	sout | nl;
-
-	sout | "long long int";
+		printf( "floor2(%lu, %lu) = %lu, floor2(%lu, %lu) = %lu, floor2(%lu, %lu) = %lu\n", uli, uli, ulir1, uli + 2h, uli, ulir2, -uli - 2h, uli, ulir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "long long int\n" );
 	for ( lli = 1; lli != 0; lli <<= 1 ) {
 		llir1 = floor2( lli, lli ); llir2 = floor2( lli + 2hh, lli ); llir3 = floor2( -lli - 2hh, lli );
-//		printf( "floor2(%lld, %lld) = %lld, floor2(%lld, %lld) = %lld, floor2(%lld, %lld) = %lld\n", lli, lli, llir1, lli + 2ll, lli, llir2, -lli - 2ll, lli, llir3 );
-		sout | "floor2(" | lli | "," | lli | ") = " | llir1 | ", floor2(" | lli + 2ll | "," | lli | ") = " | llir2 | ", floor2(" | -lli - 2ll | "," | lli | ") = " | llir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned long long int";
+		printf( "floor2(%lld, %lld) = %lld, floor2(%lld, %lld) = %lld, floor2(%lld, %lld) = %lld\n", lli, lli, llir1, lli + 2h, lli, llir2, -lli - 2h, lli, llir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned long long int\n" );
 	for ( ulli = 1; ulli != 0; ulli <<= 1 ) {
 		ullir1 = floor2( ulli, ulli ); ullir2 = floor2( ulli + 2hh, ulli ); ullir3 = floor2( -ulli - 2hh, ulli );
-//		printf( "floor2(%llu, %llu) = %llu, floor2(%llu, %llu) = %llu, floor2(%llu, %llu) = %llu\n", ulli, ulli, ullir1, ulli + 2h, ulli, ullir2, -ulli - 2h, ulli, ullir3 );
-		sout | "floor2(" | ulli | "," | ulli | ") = " | ullir1 | ", floor2(" | ulli + 2ll | "," | ulli | ") = " | ullir2 | ", floor2(" | -ulli - 2ll | "," | ulli | ") = " | ullir3;
-	} // for
-	sout | nl;
+		printf( "floor2(%llu, %llu) = %llu, floor2(%llu, %llu) = %llu, floor2(%llu, %llu) = %llu\n", ulli, ulli, ullir1, ulli + 2h, ulli, ullir2, -ulli - 2h, ulli, ullir3 );
+	} // for
+	printf( "\n" );
 #endif // 0
 	//============================================================
@@ -217,83 +207,73 @@
 	sout | nl | "ceiling2" | nl | nl;
 
-	sout | "signed char";
+	printf( "signed char\n" );
 	for ( sc = 1; sc != 0; sc <<= 1 ) {
 		scr1 = ceiling2( sc, sc ); scr2 = ceiling2( sc + 2hh, sc ); scr3 = ceiling2( -sc - 2hh, sc );
-//		printf( "ceiling2(%hhd, %hhd) = %hhd, ceiling2(%hhd, %hhd) = %hhd, ceiling2(%hhd, %hhd) = %hhd\n", sc, sc, scr1, sc + 2hh, sc, scr2, -sc - 2hh, sc, scr3 );
-		sout | "ceiling2(" | sc | "," | sc | ") = " | scr1 | ", ceiling2(" | sc + 2hh | "," | sc | ") = " | scr2 | ", ceiling2(" | -sc - 2hh | "," | sc | ") = " | scr3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned char";
+		printf( "ceiling2(%hhd, %hhd) = %hhd, ceiling2(%hhd, %hhd) = %hhd, ceiling2(%hhd, %hhd) = %hhd\n", sc, sc, scr1, sc + 2hh, sc, scr2, -sc - 2hh, sc, scr3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned char\n" );
 	for ( uc = 1; uc != 0; uc <<= 1 ) {
 		ucr1 = ceiling2( uc, uc ); ucr2 = ceiling2( uc + 2hh, uc ); ucr3 = ceiling2( -uc - 2hh, uc );
-//		printf( "ceiling2(%hhu, %hhu) = %hhu, ceiling2(%hhu, %hhu) = %hhu, ceiling2(%hhu, %hhu) = %hhu\n", uc, uc, ucr1, uc + 2uhh, uc, ucr2, -uc - 2uhh, uc, ucr3 );
-		sout | "ceiling2(" | uc | "," | uc | ") = " | ucr1 | ", ceiling2(" | uc + 2hh | "," | uc | ") = " | ucr2 | ", ceiling2(" | -uc - 2hh | "," | uc | ") = " | ucr3;
-	} // for
-	sout | nl;
-
-	sout | "short int";
+		printf( "ceiling2(%hhu, %hhu) = %hhu, ceiling2(%hhu, %hhu) = %hhu, ceiling2(%hhu, %hhu) = %hhu\n", uc, uc, ucr1, uc + 2uhh, uc, ucr2, -uc - 2uhh, uc, ucr3 );
+	} // for
+	printf( "\n" );
+
+	printf( "short int\n" );
 	for ( si = 1; si != 0; si <<= 1 ) {
 		sir1 = ceiling2( si, si ); sir2 = ceiling2( si + 2hh, si ); sir3 = ceiling2( -si - 2hh, si );
-//		printf( "ceiling2(%hd, %hd) = %hd, ceiling2(%hd, %hd) = %hd, ceiling2(%hd, %hd) = %hd\n", si, si, sir1, si + 2h, si, sir2, -si - 2h, si, sir3 );
-		sout | "ceiling2(" | si | "," | si | ") = " | sir1 | ", ceiling2(" | si + 2h | "," | si | ") = " | sir2 | ", ceiling2(" | -si - 2h | "," | si | ") = " | sir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned short int";
+		printf( "ceiling2(%hd, %hd) = %hd, ceiling2(%hd, %hd) = %hd, ceiling2(%hd, %hd) = %hd\n", si, si, sir1, si + 2h, si, sir2, -si - 2h, si, sir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned short int\n" );
 	for ( usi = 1; usi != 0; usi <<= 1 ) {
 		usir1 = ceiling2( usi, usi ); usir2 = ceiling2( usi + 2hh, usi ); usir3 = ceiling2( -usi - 2hh, usi );
-//		printf( "ceiling2(%hu, %hu) = %hu, ceiling2(%hu, %hu) = %hu, ceiling2(%hu, %hu) = %hu\n", usi, usi, usir1, usi + 2uh, usi, usir2, -usi - 2uh, usi, usir3 );
-		sout | "ceiling2(" | usi | "," | usi | ") = " | usir1 | ", ceiling2(" | usi + 2h | "," | usi | ") = " | usir2 | ", ceiling2(" | -usi - 2h | "," | usi | ") = " | usir3;
-	} // for
-	sout | nl;
-
-	sout | "int";
+		printf( "ceiling2(%hu, %hu) = %hu, ceiling2(%hu, %hu) = %hu, ceiling2(%hu, %hu) = %hu\n", usi, usi, usir1, usi + 2uh, usi, usir2, -usi - 2uh, usi, usir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "int\n" );
 	for ( i = 1; i != 0; i <<= 1 ) {
 		ir1 = ceiling2( i, i ); ir2 = ceiling2( i + 2hh, i ); ir3 = ceiling2( -i - 2hh, i );
-//		printf( "ceiling2(%d, %d) = %d, ceiling2(%d, %d) = %d, ceiling2(%d, %d) = %d\n", i, i, ir1, i + 2, i, ir2, -i - 2, i, ir3 );
-		sout | "ceiling2(" | i | "," | i | ") = " | ir1 | ", ceiling2(" | i + 2 | "," | i | ") = " | ir2 | ", ceiling2(" | -i - 2 | "," | i | ") = " | ir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned int";
+		printf( "ceiling2(%d, %d) = %d, ceiling2(%d, %d) = %d, ceiling2(%d, %d) = %d\n", i, i, ir1, i + 2h, i, ir2, -i - 2h, i, ir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned int\n" );
 	for ( ui = 1; ui != 0; ui <<= 1 ) {
 		uir1 = ceiling2( ui, ui ); uir2 = ceiling2( ui + 2hh, ui ); uir3 = ceiling2( -ui - 2hh, ui );
-//		printf( "ceiling2(%u, %u) = %u, ceiling2(%u, %u) = %u, ceiling2(%u, %u) = %u\n", ui, ui, uir1, ui + 2, ui, uir2, -ui - 2, ui, uir3 );
-		sout | "ceiling2(" | ui | "," | ui | ") = " | uir1 | ", ceiling2(" | ui + 2 | "," | ui | ") = " | uir2 | ", ceiling2(" | -ui - 2 | "," | ui | ") = " | uir3;
-	} // for
-	sout | nl;
-
-	sout | "long int";
+		printf( "ceiling2(%u, %u) = %u, ceiling2(%u, %u) = %u, ceiling2(%u, %u) = %u\n", ui, ui, uir1, ui + 2h, ui, uir2, -ui - 2h, ui, uir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "long int\n" );
 	for ( li = 1; li != 0; li <<= 1 ) {
 		lir1 = ceiling2( li, li ); lir2 = ceiling2( li + 2hh, li ); lir3 = ceiling2( -li - 2hh, li );
-//		printf( "ceiling2(%ld, %ld) = %ld, ceiling2(%ld, %ld) = %ld, ceiling2(%ld, %ld) = %ld\n", li, li, lir1, li + 2l, li, lir2, -li - 2l, li, lir3 );
-		sout | "ceiling2(" | li | "," | li | ") = " | lir1 | ", ceiling2(" | li + 2l | "," | li | ") = " | lir2 | ", ceiling2(" | -li - 2l | "," | li | ") = " | lir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned long int";
+		printf( "ceiling2(%ld, %ld) = %ld, ceiling2(%ld, %ld) = %ld, ceiling2(%ld, %ld) = %ld\n", li, li, lir1, li + 2h, li, lir2, -li - 2h, li, lir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned long int\n" );
 	for ( uli = 1; uli != 0; uli <<= 1 ) {
 		ulir1 = ceiling2( uli, uli ); ulir2 = ceiling2( uli + 2hh, uli ); ulir3 = ceiling2( -uli - 2hh, uli );
-//		printf( "ceiling2(%lu, %lu) = %lu, ceiling2(%lu, %lu) = %lu, ceiling2(%lu, %lu) = %lu\n", uli, uli, ulir1, uli + 2, uli, ulir2, -uli - 2, uli, ulir3 );
-		sout | "ceiling2(" | uli | "," | uli | ") = " | ulir1 | ", ceiling2(" | uli + 2l | "," | uli | ") = " | ulir2 | ", ceiling2(" | -uli - 2l | "," | uli | ") = " | ulir3;
-	} // for
-	sout | nl;
-
-	sout | "long long int";
+		printf( "ceiling2(%lu, %lu) = %lu, ceiling2(%lu, %lu) = %lu, ceiling2(%lu, %lu) = %lu\n", uli, uli, ulir1, uli + 2h, uli, ulir2, -uli - 2h, uli, ulir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "long long int\n" );
 	for ( lli = 1; lli != 0; lli <<= 1 ) {
 		llir1 = ceiling2( lli, lli ); llir2 = ceiling2( lli + 2hh, lli ); llir3 = ceiling2( -lli - 2hh, lli );
-//		printf( "ceiling2(%lld, %lld) = %lld, ceiling2(%lld, %lld) = %lld, ceiling2(%lld, %lld) = %lld\n", lli, lli, llir1, lli + 2ll, lli, llir2, -lli - 2ll, lli, llir3 );
-		sout | "ceiling2(" | lli | "," | lli | ") = " | llir1 | ", ceiling2(" | lli + 2ll | "," | lli | ") = " | llir2 | ", ceiling2(" | -lli - 2ll | "," | lli | ") = " | llir3;
-	} // for
-	sout | nl;
-
-	sout | "unsigned long long int";
+		printf( "ceiling2(%lld, %lld) = %lld, ceiling2(%lld, %lld) = %lld, ceiling2(%lld, %lld) = %lld\n", lli, lli, llir1, lli + 2h, lli, llir2, -lli - 2h, lli, llir3 );
+	} // for
+	printf( "\n" );
+
+	printf( "unsigned long long int\n" );
 	for ( ulli = 1; ulli != 0; ulli <<= 1 ) {
 		ullir1 = ceiling2( ulli, ulli ); ullir2 = ceiling2( ulli + 2hh, ulli ); ullir3 = ceiling2( -ulli - 2hh, ulli );
-//		printf( "ceiling2(%llu, %llu) = %llu, ceiling2(%llu, %llu) = %llu, ceiling2(%llu, %llu) = %llu\n", ulli, ulli, ullir1, ulli + 2h, ulli, ullir2, -ulli - 2h, ulli, ullir3 );
-		sout | "ceiling2(" | ulli | "," | ulli | ") = " | ullir1 | ", ceiling2(" | ulli + 2ll | "," | ulli | ") = " | ullir2 | ", ceiling2(" | -ulli - 2ll | "," | ulli | ") = " | ullir3;
-	} // for
-	sout | nl;
+		printf( "ceiling2(%llu, %llu) = %llu, ceiling2(%llu, %llu) = %llu, ceiling2(%llu, %llu) = %llu\n", ulli, ulli, ullir1, ulli + 2h, ulli, ullir2, -ulli - 2h, ulli, ullir3 );
+	} // for
+	printf( "\n" );
 #endif // 0
 } // main
Index: tests/mathX.cfa
===================================================================
--- tests/mathX.cfa	(revision 3b8acfbe95c3db3794731829fed72ce38aee0c4f)
+++ tests/mathX.cfa	(revision be497c6a13beb0f6db241a5dc3448ff27dadb004)
@@ -10,6 +10,6 @@
 // Created On       : Thu May 24 20:56:54 2018
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sun Aug  8 22:33:46 2021
-// Update Count     : 31
+// Last Modified On : Sat Feb 20 18:26:38 2021
+// Update Count     : 30
 //
 
@@ -255,5 +255,5 @@
 		sout | "ceiling(" | ulli | ", " | ulli | ") = " | ullir1 | ", ceiling(" | ulli + 2ull | ", " | ulli | ") = " | ullir2 | ", ceiling(" | -ulli - 2ull | ", " | ulli | ") = " | ullir3;
 	} // for
-	sout | nl;
+	printf( "\n" );
 #endif // 0
 } // main
